/***************************************************************
 * Name:      wxGuitarMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    Ivnish (INDT) (indt@mail.ru)
 * Created:   2009-07-21
 * Copyright: (c) 2009 Ivnish (INDT)
 * License:   GPLv3
 **************************************************************/

#include "wxGuitarMain.h"
#include <wx/msgdlg.h>
#include <wx/aboutdlg.h>

//(*InternalHeaders(wxGuitarFrame)
#include <wx/bitmap.h>
#include <wx/intl.h>
#include <wx/image.h>
#include <wx/string.h>
//*)

wxString    szWavName;      // Имя звукового файла, передается функции PlayWav

// Путь к ресурсам (на этапе разработки использую cвой путь,
// чтобы не копировать ресурсы в /usr/share)
//#define PATHTORES "/home/ivnish/Develop/Release/wxGuitar/data"
#define PATHTORES "/usr/share/wxguitar"

//(*IdInit(wxGuitarFrame)
const long wxGuitarFrame::ID_BUTTON1 = wxNewId();
const long wxGuitarFrame::ID_BUTTON2 = wxNewId();
const long wxGuitarFrame::ID_BUTTON3 = wxNewId();
const long wxGuitarFrame::ID_BUTTON4 = wxNewId();
const long wxGuitarFrame::ID_BUTTON5 = wxNewId();
const long wxGuitarFrame::ID_BUTTON6 = wxNewId();
const long wxGuitarFrame::ID_STATICBITMAP1 = wxNewId();
const long wxGuitarFrame::ID_CHECKBOX1 = wxNewId();
const long wxGuitarFrame::ID_SPINCTRL1 = wxNewId();
const long wxGuitarFrame::ID_STATICTEXT1 = wxNewId();
const long wxGuitarFrame::idMenuQuit = wxNewId();
const long wxGuitarFrame::idMenuAbout = wxNewId();
const long wxGuitarFrame::ID_TIMER1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(wxGuitarFrame,wxFrame)
    //(*EventTable(wxGuitarFrame)
    //*)
END_EVENT_TABLE()

wxGuitarFrame::wxGuitarFrame(wxWindow* parent,wxWindowID id)
{
    // Создаем локаль
    wxLocale *m_Locale = new wxLocale();
    // Инициализируем ее дефо параметрами
    m_Locale->Init();
    // И добавляем домен
    m_Locale->AddCatalog(_("wxguitar"));

    //(*Initialize(wxGuitarFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxFlexGridSizer* FlexGridSizer2;
    wxBoxSizer* BoxSizer2;
    wxMenu* Menu1;
    wxBoxSizer* BoxSizer1;
    wxMenuBar* MenuBar1;
    wxFlexGridSizer* FlexGridSizer1;
    wxMenu* Menu2;

    Create(parent, id, _("wxGuitar 1.01"), wxDefaultPosition, wxDefaultSize, wxCAPTION|wxCLOSE_BOX|wxMINIMIZE_BOX, _T("id"));
    {
    	wxIcon FrameIcon;
    	FrameIcon.CopyFromBitmap(wxBitmap(wxImage(_T(PATHTORES"/pixmaps/gitara_icon_64.ico"))));
    	SetIcon(FrameIcon);
    }
    BoxSizer1 = new wxBoxSizer(wxVERTICAL);
    BoxSizer2 = new wxBoxSizer(wxHORIZONTAL);
    FlexGridSizer2 = new wxFlexGridSizer(6, 0, 8, 0);
    Button1 = new wxButton(this, ID_BUTTON1, _("E"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    FlexGridSizer2->Add(Button1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Button2 = new wxButton(this, ID_BUTTON2, _("H"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    FlexGridSizer2->Add(Button2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Button3 = new wxButton(this, ID_BUTTON3, _("G"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
    FlexGridSizer2->Add(Button3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Button4 = new wxButton(this, ID_BUTTON4, _("D"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON4"));
    FlexGridSizer2->Add(Button4, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Button5 = new wxButton(this, ID_BUTTON5, _("A"), wxPoint(0,0), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON5"));
    FlexGridSizer2->Add(Button5, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Button6 = new wxButton(this, ID_BUTTON6, _("E"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON6"));
    FlexGridSizer2->Add(Button6, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    BoxSizer2->Add(FlexGridSizer2, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 12);
    StaticBitmap1 = new wxStaticBitmap(this, ID_STATICBITMAP1, wxNullBitmap, wxDefaultPosition, wxSize(190,327), 0, _T("ID_STATICBITMAP1"));
    BoxSizer2->Add(StaticBitmap1, 1, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    BoxSizer1->Add(BoxSizer2, 0, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 3);
    FlexGridSizer1 = new wxFlexGridSizer(0, 3, 0, 0);
    CheckBox1 = new wxCheckBox(this, ID_CHECKBOX1, _("repeat every"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
    CheckBox1->SetValue(false);
    FlexGridSizer1->Add(CheckBox1, 0, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
    SpinCtrl1 = new wxSpinCtrl(this, ID_SPINCTRL1, _T("3"), wxDefaultPosition, wxSize(58,27), 0, 3, 10, 3, _T("ID_SPINCTRL1"));
    SpinCtrl1->SetValue(_T("3"));
    FlexGridSizer1->Add(SpinCtrl1, 0, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _("seconds"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    FlexGridSizer1->Add(StaticText1, 0, wxALL|wxALIGN_RIGHT|wxALIGN_CENTER_VERTICAL, 5);
    BoxSizer1->Add(FlexGridSizer1, 0, wxALL|wxEXPAND|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 0);
    SetSizer(BoxSizer1);
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _("Quit\tAlt-F4"), wxEmptyString, wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _("About\tF1"), wxEmptyString, wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Help"));
    SetMenuBar(MenuBar1);
    Timer1.SetOwner(this, ID_TIMER1);
    BoxSizer1->Fit(this);
    BoxSizer1->SetSizeHints(this);
    Center();

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxGuitarFrame::OnButton1Click);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxGuitarFrame::OnButton2Click);
    Connect(ID_BUTTON3,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxGuitarFrame::OnButton3Click);
    Connect(ID_BUTTON4,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxGuitarFrame::OnButton4Click);
    Connect(ID_BUTTON5,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxGuitarFrame::OnButton5Click);
    Connect(ID_BUTTON6,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxGuitarFrame::OnButton6Click);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxGuitarFrame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxGuitarFrame::OnAbout);
    Connect(ID_TIMER1,wxEVT_TIMER,(wxObjectEventFunction)&wxGuitarFrame::OnTimer1Trigger);
    //*)

    // Загружаем изображение гитары
    StaticBitmap1->SetBitmap(wxBitmap(_T(PATHTORES"/pixmaps/gitara.png"),wxBITMAP_TYPE_PNG));
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

wxGuitarFrame::~wxGuitarFrame()
{
    //(*Destroy(wxGuitarFrame)
    //*)
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик пункта меню "Выход"
void wxGuitarFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик пункта меню "О программе"
void wxGuitarFrame::OnAbout(wxCommandEvent& event)
{
    wxAboutDialogInfo info;
    info.SetName(_T("wxGuitar"));
    info.SetVersion(_T("1.01"));
    info.SetDescription(_("Simple program to help to tune your guitar."));
    info.SetCopyright(_T("Copyright (c) 2009 Andrey \"Ivnish\" Ivnitsky"));
    info.AddDeveloper(_T("Andrey \"Ivnish\" Ivnitsky <indt@mail.ru>"));
    info.AddTranslator(_T("Andrey \"Ivnish\" Ivnitsky <indt@mail.ru>"));
    wxAboutBox(info);
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Функция воспроизводит переданный ей файл
void PlayWav(wxString szWavName)
{
    wxString szBuf = _T("aplay -q ")+szWavName;
    char szAnsi[255];
    wxMBConvUTF8 conv;
    conv.WC2MB(szAnsi,szBuf.wc_str(),255);
    system(szAnsi);
}
/////////////////////////////////////////////////////////////////////////////////////////

// Функция проверяет поставлен ли чекбокс и если да,
// то запускает таймер (останавливать таймер перед этим необязательно,
// в документации говорят, что это делается автоматом)
// Если же таймер уже запущен, чекбокс снят, то таймер останавливается
void wxGuitarFrame::PlayAndCheckTimer()
{
    PlayWav(szWavName);

    if (CheckBox1->IsChecked())
        Timer1.Start(SpinCtrl1->GetValue()*1000);
    else
    if (Timer1.IsRunning())
        Timer1.Stop();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик таймера
void wxGuitarFrame::OnTimer1Trigger(wxTimerEvent& event)
{
    PlayWav(szWavName); // Повторяем звук струны
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик кнопки первой струны
void wxGuitarFrame::OnButton1Click(wxCommandEvent& event)
{
    szWavName = _T(PATHTORES"/sounds/E1.wav");
    PlayAndCheckTimer();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик кнопки второй струны
void wxGuitarFrame::OnButton2Click(wxCommandEvent& event)
{
    szWavName = _T(PATHTORES"/sounds/H1.wav");
    PlayAndCheckTimer();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик кнопки третьей струны
void wxGuitarFrame::OnButton3Click(wxCommandEvent& event)
{
    szWavName = _T(PATHTORES"/sounds/G1.wav");
    PlayAndCheckTimer();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик кнопки четвертой струны
void wxGuitarFrame::OnButton4Click(wxCommandEvent& event)
{
    szWavName = _T(PATHTORES"/sounds/D1.wav");
    PlayAndCheckTimer();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик кнопки пятой струны
void wxGuitarFrame::OnButton5Click(wxCommandEvent& event)
{
    szWavName = _T(PATHTORES"/sounds/A1.wav");
    PlayAndCheckTimer();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////

// Обработчик кнопки шестой струны
void wxGuitarFrame::OnButton6Click(wxCommandEvent& event)
{
    szWavName = _T(PATHTORES"/sounds/E2.wav");
    PlayAndCheckTimer();
}
////////////////////////////////////////////////////////////////////////////////////////////////////////
